///////////////////////////////////////////////////////////////////////////////////////
// 
// Serial Port Processing
///////////////////////////////////////////////////////////////////////////////////////
int PairMiss =0;

void serialDataOut()
{
  // Create single text parameter and print it
      if ( (rtk.heading +10) < GPSrxs ) {
        GPSrxs = rtk.heading;
        PairMiss++;
        //coutD.print( "\n ! ! ! ! ! ! ! !! ! ! !! !! ! ! ! !!!! ! ! !   PairMiss" );
        //coutD.print( PairMiss );
        //coutD.println( "\n ! ! ! ! ! ! ! !! ! ! !! !! ! ! ! !!!! ! ! !" );
      }
      if(timeStamp*0.001 > 235.0 && timeStamp*0.001< 275) 
            incMissed++;
      coutD.print( rtk.heading );
      coutD.print( "==" );
      coutD.print( GPSrxs ); 
      coutD.print( "\t |tS="); 
      coutD.print( timeStamp*.001 ); 
      if ( rtk.heading != GPSrxs ) {
        coutD.print( "\t - " );
        coutD.print( GPSrxs - rtk.heading );
        coutD.print( " - " );
        coutD.print( PairMiss );
        coutD.print( " - " );
      }
      else
        coutD.print( " | " );
      if ( PairMiss ) {
        coutD.print( " == "); 
        coutD.print(PairMiss);
        coutD.print( " == "); 
        coutD.print(incMissed); coutD.println();
      }
 
  cout.printf("%10.6f, %10.6f, %10.6f, %8.3f, %d",
           timeStamp*0.001, rtk.utcTime, IMU_RX_time*0.000001, 
           _dt, rtk.fixType);
  cout.send_now();
  cout.printf("%12.8lf,%12.8lf,%10.4f", rtk.lat1, rtk.lon1, rtk.hMSL);
  cout.send_now();
  cout.printf("%10.4f,%10.4f,%10.4f", rtk.velN, rtk.velE, rtk.velD);
  cout.send_now();
  cout.printf("%10.4f,%10.4f,%10.4f", ypr[1], ypr[2], ypr[0]);
  cout.send_now();
  cout.printf("%10.4f,%10.4f,%10.4f\n",aNEDx1, aNEDy1, aNEDz1);
  cout.send_now();
  #ifdef coutD
    coutD.print("\n");
  #endif
}




void serialPortOut(){  
   
  // Set textLength to the number of parameters to print * 31
  int  textLength = 15 * 31;
  char text[textLength];
  
  //Temporary text parameters
  char acc_xText[30];
  char acc_yText[30];
  char acc_zText[30];
  char accNED_xText[30];
  char accNED_yText[30];
  char accNED_zText[30];
  char dtText[30];
  
  char utcText[30];
  char fixTypeText[30];
  char latText[30];
  char lonText[30];
  char altText[30];
  char velNText[30];
  char velEText[30];
  char velDText[30];
  
  //char acc_zGText[30];
  //char gyro_xText[30];
  //char gyro_yText[30];
  //char gyro_zText[30];
  
  char pitchText[30];
  char rollText[30];
  char yawText[30];

  // Convert parameters to text
  /*
  dtostrf(ax1, 10, 4, acc_xText);
  dtostrf(ay1, 10, 4, acc_yText);
  dtostrf(az1, 10, 4, acc_zText);
  dtostrf(magHead, 10, 4, acc_zGText);
  dtostrf(grx, 10, 4, gyro_xText);
  dtostrf(gry, 10, 4, gyro_yText);
  dtostrf(grz, 10, 4, gyro_zText);
  */
  //dtostrf(float(uBloxData.iTOW)/1000.0, 10, 4, iTOWText);

  //utcTime = float(uBloxData.utcHour)*60.0f*60.0f +
  //          float(uBloxData.utcMin) *60.0f +
  //          float(uBloxData.utcSec) +
  //          float(uBloxData.utcNano)/1000000000.0;
            
  dtostrf(utcTime, 10, 10, utcText);
  dtostrf(_dt, 10, 10, dtText);
  
  dtostrf(uBloxData.fixType, 10, 7, fixTypeText);
  dtostrf(uBloxData.lat, 10, 7, latText);
  dtostrf(uBloxData.lon, 10, 7, lonText);
  dtostrf(uBloxData.height, 10, 7, altText);
  dtostrf(uBloxData.velN, 10, 4, velNText);
  dtostrf(uBloxData.velE, 10, 4, velEText);
  dtostrf(uBloxData.velD, 10, 4, velDText);

  dtostrf(ypr[1], 10, 4, pitchText);
  dtostrf(ypr[2], 10, 4, rollText);
  dtostrf(ypr[0], 10, 4, yawText);
  //dtostrf(ax1, 10, 4, acc_xText);
  //dtostrf(ay1, 10, 4, acc_yText);
  //dtostrf(az1, 10, 4, acc_zText);
  dtostrf(aNEDx1, 10, 4, accNED_xText);
  dtostrf(aNEDy1, 10, 4, accNED_yText);
  dtostrf(aNEDz1, 10, 4, accNED_zText);
  
  // Create single text parameter and print it
  snprintf(text, textLength, "%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s",
           utcText, dtText, fixTypeText,
           latText, lonText, altText,
           velNText, velEText, velDText,
           pitchText, rollText, yawText,
           accNED_xText, accNED_yText, accNED_zText);
  cout.println(text); 
  cout.send_now();        
}    
 
